package de.donmanfred;

import thereisnospon.codeview.Code.Language;
import thereisnospon.codeview.CodeView;
import thereisnospon.codeview.CodeViewTheme;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.CustomViewWrapper;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.collections.Map;

@Version(1.00f)
@ShortName("CodeView")
@Author(value = "DonManfred (wrapper)")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
@DependsOn(values={"com.android.support:support-v4","codeview.aar","jsoup-1.9.2"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 */

// @DesignerProperties(values = {
//		@Property(key="Checked", displayName="Checked", defaultValue="False", fieldType="Boolean")
//	})
public class CodeViewWrapper extends ViewWrapper<CodeView> implements DesignerCustomView{
	private BA ba;
	private String eventName;

  public static final String EXAMPLECODE="#include<iostream>  \n" +
      "#include<queue>  \n" +
      "#include<string>  \n" +
      "#include<cstdio>  \n" +
      "#include<cstring>  \n" +
      "#include<vector>  \n" +
      "#define MAX 2005  \n" +
      "using namespace std;  \n" +
      "int in[MAX];  \n" +
      "vector<int>G[MAX];  \n" +
      "int TopSort(int n)  \n" +
      "{  \n" +
      "    queue<int>p;  \n" +
      "    int i, t, Count = 0;  \n" +
      "    for (i = 1; i <= n; i++)  \n" +
      "        if (in[i] == 0)  \n" +
      "            p.push(i);  \n" +
      "    while (!p.empty())  \n" +
      "    {  \n" +
      "        t = p.front(); p.pop();  \n" +
      "        Count++;  \n" +
      "        for (i = 0; i < G[t].size(); i++)  \n" +
      "        {  \n" +
      "            in[G[t][i]]--;  \n" +
      "            if (in[G[t][i]] == 0)  \n" +
      "                p.push(G[t][i]);  \n" +
      "        }  \n" +
      "    }  \n" +
      "    if (Count <n)  \n" +
      "        return 1;  \n" +
      "    else return 0;  \n" +
      "  \n" +
      "}  \n" +
      "int main()  \n" +
      "{  \n" +
      "    int n, t, i, j, cc = 0;  \n" +
      "    cin.sync_with_stdio(false);  \n" +
      "    string s;  \n" +
      "    cin >> t;  \n" +
      "    while (t--)  \n" +
      "    {      \n" +
      "        cc++;  \n" +
      "        cin >> n;  \n" +
      "        memset(in, 0, sizeof(in));  \n" +
      "        for (int i = 0; i <= n; i++) G[i].clear();  \n" +
      "        for (i = 1; i <= n; i++)  \n" +
      "        {  \n" +
      "            cin >> s;  \n" +
      "            for (j = 0; j < s.size(); j++)  \n" +
      "            {  \n" +
      "                if (s[j] == '1')  \n" +
      "                {  \n" +
      "                    G[i].push_back(j + 1);  \n" +
      "                    in[j+1]++;  \n" +
      "  \n" +
      "                }  \n" +
      "            }  \n" +
      "        }  \n" +
      "        if (TopSort(n))  \n" +
      "            printf(\"Case #%d: Yes\\n\", cc);  \n" +
      "        else printf(\"Case #%d: No\\n\", cc);  \n" +
      "    }  \n" +
      "    return 0;  \n" +
      "}  ";

	
	
	@Override
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, Map props) {
		//getObject().setChecked((Boolean)props.Get("Checked"));
		CustomViewWrapper.replaceBaseWithView(base, getObject());
	}
	public void Initialize(final BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	@Override
	public void _initialize(final BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;

		final CodeView _obj = new CodeView(ba.context);
		final String eventName = EventName.toLowerCase(BA.cul);
		setObject(_obj);
		innerInitialize(ba, eventName, true);
	}
	
  public CodeViewWrapper setTheme(CodeViewTheme theme){
  	getObject().setTheme(theme);
  	return this;
  }
  public CodeViewWrapper setEncode(String encode){
  	getObject().setEncode(encode);
    return this;
  }

  public void setBaseUrl(String baseUrl) {
  	getObject().setBaseUrl(baseUrl);
  }
  public void setHistoryUrl(String historyUrl) {
  	getObject().setHistoryUrl(historyUrl);
  }
//  public void showCode(Code code){
//  	getObject().showCode(code);
//  }

  public CodeViewWrapper fillColor(){
  	getObject().fillColor();
    return this;
  }
  public void showCodeHtmlByCssSelect(String localHtml, String cssSelect){
  	getObject().showCodeHtmlByCssSelect(localHtml, cssSelect);
  }
  public void showCodeHtmlByClass(String localHtml, String codeClass){
  	getObject().showCodeHtmlByClass(localHtml, codeClass);
  }
  public void showCode2(String code){
  	getObject().showCode(code);
  }

  public void showCode3(String code){
  	getObject().showCode(code, Language.AUTO);
  }

  public int getCodeBackgroundColor(){
    return getObject().getCodeBackgroundColor();
  }

  public CodeViewTheme getThemeAGATE(){
    return CodeViewTheme.AGATE;
  }
  public CodeViewTheme getThemeANDROIDSTUDIO(){
    return CodeViewTheme.ANDROIDSTUDIO;
  }
  public CodeViewTheme getThemeARDUINO_LIGHT(){
    return CodeViewTheme.ARDUINO_LIGHT;
  }
  public CodeViewTheme getThemeARTA(){
    return CodeViewTheme.ARTA;
  }
  public CodeViewTheme getThemeATELIER_CAVE_DARK(){
    return CodeViewTheme.ATELIER_CAVE_DARK;
  }
  public CodeViewTheme getThemeATELIER_CAVE_LIGHT(){
    return CodeViewTheme.ATELIER_CAVE_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_DUNE_DARK(){
    return CodeViewTheme.ATELIER_DUNE_DARK;
  }
  public CodeViewTheme getThemeATELIER_DUNE_LIGHT(){
    return CodeViewTheme.ATELIER_DUNE_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_ESTUARY_DARK(){
    return CodeViewTheme.ATELIER_ESTUARY_DARK;
  }
  public CodeViewTheme getThemeATELIER_ESTUARY_LIGHT(){
    return CodeViewTheme.ATELIER_ESTUARY_LIGHT;
  }

  public CodeViewTheme getThemeATELIER_FOREST_DARK(){
    return CodeViewTheme.ATELIER_FOREST_DARK;
  }
  public CodeViewTheme getThemeATELIER_FOREST_LIGHT(){
    return CodeViewTheme.ATELIER_FOREST_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_HEATH_DARK(){
    return CodeViewTheme.ATELIER_HEATH_DARK;
  }
  public CodeViewTheme getThemeATELIER_HEATH_LIGHT(){
    return CodeViewTheme.ATELIER_HEATH_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_LAKESIDE_DARK(){
    return CodeViewTheme.ATELIER_LAKESIDE_DARK;
  }
  public CodeViewTheme getThemeATELIER_SEASIDE_DARK(){
    return CodeViewTheme.ATELIER_SEASIDE_DARK;
  }
  public CodeViewTheme getThemeATELIER_SEASIDE_LIGHT(){
    return CodeViewTheme.ATELIER_SEASIDE_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_SULPHURPOOL_DARK(){
    return CodeViewTheme.ATELIER_SULPHURPOOL_DARK;
  }
  public CodeViewTheme getThemeATELIER_SULPHURPOOL_LIGHT(){
    return CodeViewTheme.ATELIER_SULPHURPOOL_LIGHT;
  }
  public CodeViewTheme getThemeCODEPEN_EMBED(){
    return CodeViewTheme.CODEPEN_EMBED;
  }
  public CodeViewTheme getThemeATELIER_SAVANNA_LIGHT(){
    return CodeViewTheme.ATELIER_SAVANNA_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_SAVANNA_DARK(){
    return CodeViewTheme.ATELIER_SAVANNA_DARK;
  }
  public CodeViewTheme getThemeATELIER_PLATEAU_LIGHT(){
    return CodeViewTheme.ATELIER_PLATEAU_LIGHT;
  }
  public CodeViewTheme getThemeATELIER_PLATEAU_DARK(){
    return CodeViewTheme.ATELIER_PLATEAU_DARK;
  }
  public CodeViewTheme getThemeATELIER_LAKESIDE_LIGHT(){
    return CodeViewTheme.ATELIER_LAKESIDE_LIGHT;
  }

  public CodeViewTheme getThemeCOLOR_BREWER(){
    return CodeViewTheme.COLOR_BREWER;
  }
  public CodeViewTheme getThemeDARK(){
    return CodeViewTheme.DARK;
  }
  public CodeViewTheme getThemeDARKULA(){
    return CodeViewTheme.DARKULA;
  }
  public CodeViewTheme getThemeDEFAULT(){
    return CodeViewTheme.DEFAULT;
  }
  public CodeViewTheme getThemeDOCCO(){
    return CodeViewTheme.DOCCO;
  }
  public CodeViewTheme getThemeDRACULA(){
    return CodeViewTheme.DRACULA;
  }
  public CodeViewTheme getThemeFAR(){
    return CodeViewTheme.FAR;
  }
  public CodeViewTheme getThemeFOUNDATION(){
    return CodeViewTheme.FOUNDATION;
  }
  public CodeViewTheme getThemeGITHUB(){
    return CodeViewTheme.GITHUB;
  }
  public CodeViewTheme getThemeGRAYSCALE(){
    return CodeViewTheme.GRAYSCALE;
  }
  public CodeViewTheme getThemeGRUVBOX_DARK(){
    return CodeViewTheme.GRUVBOX_DARK;
  }
  public CodeViewTheme getThemeGRUVBOX_LIGHT(){
    return CodeViewTheme.GRUVBOX_LIGHT;
  }
  public CodeViewTheme getThemeHOPSCOTCH(){
    return CodeViewTheme.HOPSCOTCH;
  }
  public CodeViewTheme getThemeHYBRID(){
    return CodeViewTheme.HYBRID;
  }
  public CodeViewTheme getThemeIDEA(){
    return CodeViewTheme.IDEA;
  }
  public CodeViewTheme getThemeIR_BLACK(){
    return CodeViewTheme.IR_BLACK;
  }
  public CodeViewTheme getThemeMONO_BLUE(){
    return CodeViewTheme.MONO_BLUE;
  }
  public CodeViewTheme getThemeMONOKAI_SUBLIME(){
    return CodeViewTheme.MONOKAI_SUBLIME;
  }
  public CodeViewTheme getThemeMONOKAI(){
    return CodeViewTheme.MONOKAI;
  }
  public CodeViewTheme getThemeOBSIDIAN(){
    return CodeViewTheme.OBSIDIAN;
  }
  public CodeViewTheme getThemePARAISO_DARK(){
    return CodeViewTheme.PARAISO_DARK;
  }
  public CodeViewTheme getThemePARAISO_LIGHT(){
    return CodeViewTheme.PARAISO_LIGHT;
  }
  public CodeViewTheme getThemePOJOAQUE(){
    return CodeViewTheme.POJOAQUE;
  }
  public CodeViewTheme getThemePUREBASIC(){
    return CodeViewTheme.PUREBASIC;
  }
  public CodeViewTheme getThemeQTCREATOR_DARK(){
    return CodeViewTheme.QTCREATOR_DARK;
  }
  public CodeViewTheme getThemeQTCREATOR_LIGHT(){
    return CodeViewTheme.QTCREATOR_LIGHT;
  }
  public CodeViewTheme getThemeRAILSCASTS(){
    return CodeViewTheme.RAILSCASTS;
  }
  public CodeViewTheme getThemeRAINBOW(){
    return CodeViewTheme.RAINBOW;
  }
  public CodeViewTheme getThemeSOLARIZED_DARK(){
    return CodeViewTheme.SOLARIZED_DARK;
  }
  public CodeViewTheme getThemeSOLARIZED_LIGHT(){
    return CodeViewTheme.SOLARIZED_LIGHT;
  }
  public CodeViewTheme getThemeSUNBURST(){
    return CodeViewTheme.SUNBURST;
  }
  public CodeViewTheme getThemeTOMORROW_NIGHT_BLUE(){
    return CodeViewTheme.TOMORROW_NIGHT_BLUE;
  }
  public CodeViewTheme getThemeTOMORROW_NIGHT_EIGHTIES(){
    return CodeViewTheme.TOMORROW_NIGHT_EIGHTIES;
  }
  public CodeViewTheme getThemeTOMORROW_NIGHT(){
    return CodeViewTheme.TOMORROW_NIGHT;
  }
  public CodeViewTheme getThemeXCODE(){
    return CodeViewTheme.XCODE;
  }
  public CodeViewTheme getThemeXT256(){
    return CodeViewTheme.XT256;
  }
  public CodeViewTheme getThemeZENBURN(){
    return CodeViewTheme.ZENBURN;
  }

		
}
